﻿using RimWorld;
using Verse;

namespace SimpleSlaveryCollars
{
    public class RoleRequirement_SlaveStage : RoleRequirement
    {
        public override string GetLabel(Precept_Role role) => (string)this.labelKey.Translate((NamedArgument)Find.ActiveLanguageWorker.WithIndefiniteArticle(role.ideo.memberName, Gender.None));

        public override bool Met(Pawn p, Precept_Role role)
        {
            if (p.IsSlaveOfColony && (SlaveUtility.TimeAsSlave(p) < SlaveUtility.SlaveStage4 || SlaveUtility.IsSteadfast(p)))
                return false;
            return true;
        }
    }
}
