﻿using HugsLib;
using HugsLib.Settings;
using Verse;

namespace SimpleSlaveryCollars
{
	class SimpleSlaveryCollars : ModBase
	{
		public static SimpleSlaveryCollars Inst { get; private set; }
		public static HugsLib.Utils.ModLogger InstLogger => Inst.Logger;
		public override string ModIdentifier => "SimpleSlaveryCollars";
		public static bool ShacklesDefault => Inst.shacklesDefault.Value;
		public static bool SlavestageEnable => Inst.slavestageEnable.Value;
		public static bool RebelCycleChangeEnable => Inst.rebelcyclechangeEnable.Value;
		public static bool RemoveWorkspeedDebuffEnable => Inst.removeworkspeeddebuffEnable.Value;
		public static bool AssignSlaveEnable => Inst.assignslaveEnable.Value;
		public static float Slavestage1Period => Inst.slavestage1Period.Value;
		public static float Slavestage2Period => Inst.slavestage2Period.Value;
		public static float Slavestage3Period => Inst.slavestage3Period.Value;
		public static float Slavestage4Period => Inst.slavestage4Period.Value;

		private SettingHandle<bool> shacklesDefault;
		private SettingHandle<bool> slavestageEnable;
		private SettingHandle<bool> rebelcyclechangeEnable;
		private SettingHandle<bool> removeworkspeeddebuffEnable;
		private SettingHandle<bool> assignslaveEnable;
		private SettingHandle<float> slavestage1Period;
		private SettingHandle<float> slavestage2Period;
		private SettingHandle<float> slavestage3Period;
		private SettingHandle<float> slavestage4Period;

		SimpleSlaveryCollars()
		{
			Inst = this;
		}
		public override void DefsLoaded()
		{
			shacklesDefault = Settings.GetHandle("ssshacklesDefault",
				"shacklesDefaultSetting_title".Translate(),
				"shacklesDefaultSetting_desc".Translate(),
				true);
			slavestageEnable = Settings.GetHandle("ssslavestageEnable",
				"slavestageEnableSetting_title".Translate(),
				"slavestageEnableSetting_desc".Translate(),
				true);
			rebelcyclechangeEnable = Settings.GetHandle("ssrebelcyclechangeEnable",
				"rebelcyclechangeEnableSetting_title".Translate(),
				"rebelcyclechangeEnableSetting_desc".Translate(),
				true);
			removeworkspeeddebuffEnable = Settings.GetHandle("ssremoveworkspeeddebuffEnable",
				"removeworkspeeddebuffEnableSetting_title".Translate(),
				"removeworkspeeddebuffEnableSetting_desc".Translate(),
				true);
			assignslaveEnable = Settings.GetHandle("ssassignslaveEnable",
				"assignslaveEnableSetting_title".Translate(),
				"assignslaveEnableSetting_desc".Translate(),
				true);
			slavestage1Period = Settings.GetHandle("ssSlavestage1Period",
				"slavestage1Period_title".Translate(),
				"slavestage1Period_desc".Translate(),
				15f);
			slavestage2Period = Settings.GetHandle("ssSlavestage2Period",
				"slavestage2Period_title".Translate(),
				"slavestage2Period_desc".Translate(),
				15f);
			slavestage3Period = Settings.GetHandle("ssSlavestage3Period",
				"slavestage3Period_title".Translate(),
				"slavestage3Period_desc".Translate(),
				15f);
			slavestage4Period = Settings.GetHandle("ssSlavestage4Period",
				"slavestage4Period_title".Translate(),
				"slavestage4Period_desc".Translate(),
				15f);
		}
	}
}
