﻿using RimWorld;
using Verse;

namespace SimpleSlaveryCollars
{
	public class ThoughtWorker_Enslaved : ThoughtWorker
	{
		protected override ThoughtState CurrentStateInternal(Pawn p)
		{
			if (SimpleSlaveryCollars.SlavestageEnable == false)
				return ThoughtState.Inactive;
			if (p.IsSlaveOfColony)
			{
				if (SlaveUtility.TimeAsSlave(p) < SlaveUtility.SlaveStage1)
					return ThoughtState.ActiveAtStage(0);
				else if (SlaveUtility.TimeAsSlave(p) < SlaveUtility.SlaveStage2)
					return ThoughtState.ActiveAtStage(1);
				else if (SlaveUtility.TimeAsSlave(p) < SlaveUtility.SlaveStage3)
					return ThoughtState.ActiveAtStage(2);
				else if (SlaveUtility.TimeAsSlave(p) < SlaveUtility.SlaveStage4 || (SlaveUtility.TimeAsSlave(p) >= SlaveUtility.SlaveStage3 && SlaveUtility.IsSteadfast(p)))
					return ThoughtState.ActiveAtStage(3);
				else if (SlaveUtility.TimeAsSlave(p) >= SlaveUtility.SlaveStage4)
					return ThoughtState.ActiveAtStage(4);
			}
			return ThoughtState.Inactive;
		}
	}
}

